/*
MPEG 2 decoder bitstream xfer
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define	TRUE		1
#define	FALSE		0

unsigned	char	buffer422[1920 * 1088 * 2];

int main(int argc, char **argv)
{
	FILE	*fpout;
	unsigned int	i, j, index = 0;
	unsigned char	y;
	double	f, value;

	if (argc != 2) {
		fprintf(stderr, "usage: pat<outfile>\n");
		exit(-1);
	}

	/*--- open binary file (for parsing) ---*/
	fpout = fopen(argv[1], "wb");
	if (fpout == 0) {
		fprintf(stderr, "Cannot open output file <%s>\n", argv[1]);
		exit(-1);
	}

	y = 16;
	for(j = 0; j < 270; j++)  {
		for(i = 0; i < 8; i++)  {
			buffer422[index++] = 0x80;
			buffer422[index++] = 0x80;
		}
		for(i = 0; i < 8; i++)  {
			buffer422[index++] = 0x80;
			buffer422[index++] = 0x80;
		}
		f = ((2 * 3.141592653 * 20000000) / 74250000);
		for(i = 0; i < 460; i++)  {
			value = sin(f * (double)i);
			value = (value * 219 / 2) + (219 / 2) + 16;
			y = (unsigned char)value;
			buffer422[index++] = 0x80;
			buffer422[index++] = y;
		}
		for(i = 0; i < 16; i++)  {
			buffer422[index++] = 0x80;
			buffer422[index++] = 0x80;
		}
		f = ((2 * 3.141592653 * 21000000) / 74250000);
		for(i = 0; i < 460; i++)  {
			value = sin(f * (double)i);
			value = (value * 219 / 2) + (219 / 2) + 16;
			y = (unsigned char)value;
			buffer422[index++] = 0x80;
			buffer422[index++] = y;
		}
		for(i = 0; i < 16; i++)  {
			buffer422[index++] = 0x80;
			buffer422[index++] = 0x80;
		}
		f = ((2 * 3.141592653 * 22000000) / 74250000);
		for(i = 0; i < 460; i++)  {
			value = sin(f * (double)i);
			value = (value * 219 / 2) + (219 / 2) + 16;
			y = (unsigned char)value;
			buffer422[index++] = 0x80;
			buffer422[index++] = y;
		}
		for(i = 0; i < 16; i++)  {
			buffer422[index++] = 0x80;
			buffer422[index++] = 0x80;
		}
		f = ((2 * 3.141592653 * 23000000) / 74250000);
		for(i = 0; i < 460; i++)  {
			value = sin(f * (double)i);
			value = (value * 219 / 2) + (219 / 2) + 16;
			y = (unsigned char)value;
			buffer422[index++] = 0x80;
			buffer422[index++] = y;
		}
		for(i = 0; i < 8; i++)  {
			buffer422[index++] = 0x80;
			buffer422[index++] = 0x80;
		}
		for(i = 0; i < 8; i++)  {
			buffer422[index++] = 0x80;
			buffer422[index++] = 0x80;
		}
	}
	for(j = 0; j < 270; j++)  {
		for(i = 0; i < 8; i++)  {
			buffer422[index++] = 0x80;
			buffer422[index++] = 0x80;
		}
		for(i = 0; i < 8; i++)  {
			buffer422[index++] = 0x80;
			buffer422[index++] = 0x80;
		}
		f = ((2 * 3.141592653 * 24000000) / 74250000);
		for(i = 0; i < 460; i++)  {
			value = sin(f * (double)i);
			value = (value * 219 / 2) + (219 / 2) + 16;
			y = (unsigned char)value;
			buffer422[index++] = 0x80;
			buffer422[index++] = y;
		}
		for(i = 0; i < 16; i++)  {
			buffer422[index++] = 0x80;
			buffer422[index++] = 0x80;
		}
		f = ((2 * 3.141592653 * 25000000) / 74250000);
		for(i = 0; i < 460; i++)  {
			value = sin(f * (double)i);
			value = (value * 219 / 2) + (219 / 2) + 16;
			y = (unsigned char)value;
			buffer422[index++] = 0x80;
			buffer422[index++] = y;
		}
		for(i = 0; i < 16; i++)  {
			buffer422[index++] = 0x80;
			buffer422[index++] = 0x80;
		}
		f = ((2 * 3.141592653 * 26000000) / 74250000);
		for(i = 0; i < 460; i++)  {
			value = sin(f * (double)i);
			value = (value * 219 / 2) + (219 / 2) + 16;
			y = (unsigned char)value;
			buffer422[index++] = 0x80;
			buffer422[index++] = y;
		}
		for(i = 0; i < 16; i++)  {
			buffer422[index++] = 0x80;
			buffer422[index++] = 0x80;
		}
		f = ((2 * 3.141592653 * 27000000) / 74250000);
		for(i = 0; i < 460; i++)  {
			value = sin(f * (double)i);
			value = (value * 219 / 2) + (219 / 2) + 16;
			y = (unsigned char)value;
			buffer422[index++] = 0x80;
			buffer422[index++] = y;
		}
		for(i = 0; i < 8; i++)  {
			buffer422[index++] = 0x80;
			buffer422[index++] = 0x80;
		}
		for(i = 0; i < 8; i++)  {
			buffer422[index++] = 0x80;
			buffer422[index++] = 0x80;
		}
	}
	for(j = 0; j < 270; j++)  {
		for(i = 0; i < 8; i++)  {
			buffer422[index++] = 0x80;
			buffer422[index++] = 0x80;
		}
		for(i = 0; i < 8; i++)  {
			buffer422[index++] = 0x80;
			buffer422[index++] = 0x80;
		}
		f = ((2 * 3.141592653 * 28000000) / 74250000);
		for(i = 0; i < 460; i++)  {
			value = sin(f * (double)i);
			value = (value * 219 / 2) + (219 / 2) + 16;
			y = (unsigned char)value;
			buffer422[index++] = 0x80;
			buffer422[index++] = y;
		}
		for(i = 0; i < 16; i++)  {
			buffer422[index++] = 0x80;
			buffer422[index++] = 0x80;
		}
		f = ((2 * 3.141592653 * 29000000) / 74250000);
		for(i = 0; i < 460; i++)  {
			value = sin(f * (double)i);
			value = (value * 219 / 2) + (219 / 2) + 16;
			y = (unsigned char)value;
			buffer422[index++] = 0x80;
			buffer422[index++] = y;
		}
		for(i = 0; i < 16; i++)  {
			buffer422[index++] = 0x80;
			buffer422[index++] = 0x80;
		}
		f = ((2 * 3.141592653 * 30000000) / 74250000);
		for(i = 0; i < 460; i++)  {
			value = sin(f * (double)i);
			value = (value * 219 / 2) + (219 / 2) + 16;
			y = (unsigned char)value;
			buffer422[index++] = 0x80;
			buffer422[index++] = y;
		}
		for(i = 0; i < 16; i++)  {
			buffer422[index++] = 0x80;
			buffer422[index++] = 0x80;
		}
		f = ((2 * 3.141592653 * 31000000) / 74250000);
		for(i = 0; i < 460; i++)  {
			value = sin(f * (double)i);
			value = (value * 219 / 2) + (219 / 2) + 16;
			y = (unsigned char)value;
			buffer422[index++] = 0x80;
			buffer422[index++] = y;
		}
		for(i = 0; i < 8; i++)  {
			buffer422[index++] = 0x80;
			buffer422[index++] = 0x80;
		}
		for(i = 0; i < 8; i++)  {
			buffer422[index++] = 0x80;
			buffer422[index++] = 0x80;
		}
	}
	for(j = 0; j < 270; j++)  {
		for(i = 0; i < 8; i++)  {
			buffer422[index++] = 0x80;
			buffer422[index++] = 0x80;
		}
		for(i = 0; i < 8; i++)  {
			buffer422[index++] = 0x80;
			buffer422[index++] = 0x80;
		}
		f = ((2 * 3.141592653 * 32000000) / 74250000);
		for(i = 0; i < 460; i++)  {
			value = sin(f * (double)i);
			value = (value * 219 / 2) + (219 / 2) + 16;
			y = (unsigned char)value;
			buffer422[index++] = 0x80;
			buffer422[index++] = y;
		}
		for(i = 0; i < 16; i++)  {
			buffer422[index++] = 0x80;
			buffer422[index++] = 0x80;
		}
		f = ((2 * 3.141592653 * 33000000) / 74250000);
		for(i = 0; i < 460; i++)  {
			value = sin(f * (double)i);
			value = (value * 219 / 2) + (219 / 2) + 16;
			y = (unsigned char)value;
			buffer422[index++] = 0x80;
			buffer422[index++] = y;
		}
		for(i = 0; i < 16; i++)  {
			buffer422[index++] = 0x80;
			buffer422[index++] = 0x80;
		}
		f = ((2 * 3.141592653 * 34000000) / 74250000);
		for(i = 0; i < 460; i++)  {
			value = sin(f * (double)i);
			value = (value * 219 / 2) + (219 / 2) + 16;
			y = (unsigned char)value;
			buffer422[index++] = 0x80;
			buffer422[index++] = y;
		}
		for(i = 0; i < 16; i++)  {
			buffer422[index++] = 0x80;
			buffer422[index++] = 0x80;
		}
		f = ((2 * 3.141592653 * 35000000) / 74250000);
		for(i = 0; i < 460; i++)  {
			value = sin(f * (double)i);
			value = (value * 219 / 2) + (219 / 2) + 16;
			y = (unsigned char)value;
			buffer422[index++] = 0x80;
			buffer422[index++] = y;
		}
		for(i = 0; i < 8; i++)  {
			buffer422[index++] = 0x80;
			buffer422[index++] = 0x80;
		}
		for(i = 0; i < 8; i++)  {
			buffer422[index++] = 0x80;
			buffer422[index++] = 0x80;
		}
	}
	fwrite(&buffer422[0], 1, 1920 * 1080 * 2, fpout);
	fclose(fpout);
	return 0;
}
